Page MenuHomePhabricator

Hide "Herald added subscribers..." stories from feed completely
Closed, ResolvedPublic

Description

I noticed a weird looking feed item.

This was the actual event(s).

Maybe this is some sort of batching/coalescing bug? Right now it looks like the comment and the herald triggering got jammed together.

Event Timeline

sshannin created this task.Jul 24 2015, 9:45 PM
sshannin raised the priority of this task from to Needs Triage.
sshannin updated the task description. (Show Details)
sshannin added projects: Herald, Feed.
sshannin added a subscriber: sshannin.
chad added a subscriber: chad.Jul 24 2015, 10:25 PM

This is displaying as intended. That is, if there is no image available, we still outline the actor space for consistency.

chad added a comment.Jul 24 2015, 10:26 PM

Oh, yes the "Herald" as the actor is incorrect.

chad removed a subscriber: eadler.Jul 24 2015, 10:26 PM
epriestley moved this task from Backlog to Next on the Herald board.Dec 9 2015, 1:16 PM

This behavior is "correct" in some sense (Herald really did perform the "strongest" action in the transaction group) but the sorting on tiebreakers is likely wrong (see D14680 for a similar case) and we should sort actions by real users over actions by Herald at the same strength.

That is, there were three actions here:

  1. Chad added a subscriber.
  2. Chad added a comment.
  3. Herald added a subscriber,

I haven't actually looked at the values, but the result might be because of something like this:

(2) has the weakest strength (any other transaction is always more interesting than "added a comment", since we show the comment anyway), so we have a choice between (1) and (3) as the title of the feed story. We incorrectly select (3) as a stronger action, when a better choice would be (1).

However, it's actually possible that we're already doing strengths correctly -- I think we may have a special rule to make "user added <themselves> as a subscriber" into a very weak action. This legitimately makes the Herald action stronger. It should not be, so maybe we just add a rule to make "<any application> <did anything> <to subcribers>" extremely weak because that is soooo boring.

I'm not sure what we should do in this case:

  • Chad adds a subscriber.
  • In response, Herald closes the task.

In this case, "close" is legitimately very strong. What should we do?

  • Publish "Chad added a subscriber."
  • Publish "Herald closed the task."
  • (Publish both? Having Herald generate a second story is probably really bad in a lot of cases.)
  • (Something else?)

Offhand, I'm inclined to still publish "Herald closed the task." in the "subscribe + close" hypothetical, which I think is the current behavior.

chad added a comment.Dec 9 2015, 3:27 PM

Maybe slightly always ding a computer action vs. a human action. That is, if a human adds a subscriber, and herald adds a subscriber, that weight is (human action weight - 1), or something along those lines? Then if human adds a subscriber, but herald closes, the weight of the close action even though gets dinged, is likely still stronger.

From T10822, we currently choose [Changed Subscribers] as a stronger action than [Merged] for tasks in some cases in email subject lines. This is probably not the correct heuristic, [Merged] is normally a strong action.

There's some level of magical heuristic, so yell if you still see issues.

I think that story strength thing is non-retroactive? This may not really be fixed if new stories aren't better.

chad added a comment.Apr 20 2016, 9:54 PM

seems ok to me.

very nice

if it breaks again we can try adding some more 0.000000000's first and see if that helps

chad added a comment.Apr 21 2016, 7:38 PM

Deliberate Subscriber + Herald Subscriber = Herald Subscriber Story.

chad added a comment.Apr 21 2016, 7:39 PM

This is an emergency.

That's because it was deliberate self-subscribe which is so completely boring that we normally wouldn't even show it. I think it's arguably correct to show the Herald story? Maybe?

I think if you add me and Herald adds eadler, it will show "chad added epriestley".

But if you add yourself (SO BORING) and Herald adds eadler, it shows "Herald added eadler".

If we don't do that, self-adds sometimes show up and sometimes don't which is a little weird maybe? I'm not sure there's any way to resolve this that's consistent/obvious/predictable/always makes sense.

chad added a comment.Apr 21 2016, 8:10 PM

maybe herald adding a subscriber is truly 0 then as a feed story.

Like just don't show it at all? That seems reasonable to me, although 0.00000000001 is very funny and we would be losing a truly great joke at such a young age.

epriestley reopened this task as Open.Aug 22 2016, 5:55 PM

Just reopening this so I don't forget about it since I agree about that last change.

epriestley renamed this task from herald showing as cause of feed item to Hide "Herald added subscribers..." stories from feed completely.Jan 26 2018, 5:32 PM

0.00000000001 is very funny and we would be losing a truly great joke at such a young age

F

This actually died earlier in D20540, but got to live for far longer than it probably should have.